package sun.security.krb5.internal;

import java.math.BigInteger;
import sun.security.util.DerOutputStream;
import java.io.IOException;
import sun.security.krb5.Asn1Exception;
import sun.security.util.DerValue;

public class PAEncTSEnc
{
    public KerberosTime pATimeStamp;
    public Integer pAUSec;
    
    public PAEncTSEnc(KerberosTime paTimeStamp, Integer pauSec) {
        this.pATimeStamp = paTimeStamp;
        this.pAUSec = pauSec;
    }
    
    public PAEncTSEnc() {
        KerberosTime now = KerberosTime.now();
        this.pATimeStamp = now;
        this.pAUSec = new Integer(now.getMicroSeconds());
    }
    
    public PAEncTSEnc(DerValue derValue) throws Asn1Exception, IOException {
        if (derValue.getTag() != 48) {
            throw new Asn1Exception(906);
        }
        this.pATimeStamp = KerberosTime.parse(derValue.getData(), (byte)0, false);
        if (derValue.getData().available() > 0) {
            DerValue derValue2 = derValue.getData().getDerValue();
            if ((derValue2.getTag() & 0x1F) == 0x1) {
                this.pAUSec = new Integer(derValue2.getData().getBigInteger().intValue());
            }
            else {
                throw new Asn1Exception(906);
            }
        }
        if (derValue.getData().available() > 0) {
            throw new Asn1Exception(906);
        }
        return;
    }
    
    public byte[] asn1Encode() throws Asn1Exception, IOException {
        DerOutputStream derOutputStream = new DerOutputStream();
        DerOutputStream derOutputStream2 = new DerOutputStream();
        derOutputStream.write(DerValue.createTag((byte)(-128), true, (byte)0), this.pATimeStamp.asn1Encode());
        if (this.pAUSec != null) {
            DerOutputStream derOutputStream3 = new DerOutputStream();
            derOutputStream3.putInteger(BigInteger.valueOf((long)(int)this.pAUSec));
            derOutputStream.write(DerValue.createTag((byte)(-128), true, (byte)1), derOutputStream3);
        }
        DerOutputStream o = new DerOutputStream();
        o.write((byte)48, derOutputStream);
        return o.toByteArray();
    }
}
